c699ac226d54ac8c486b977b4dab5edd5c8d3c89
[lttng-tools.git] / tests / stress / test_multi_sessions_per_uid_5app_streaming_kill_relayd
1 #!/bin/bash
2 #
3 # Copyright (C) - 2013 David Goulet <dgoulet@efficios.com>
4 #
5 # This library is free software; you can redistribute it and/or modify it under
6 # the terms of the GNU Lesser General Public License as published by the Free
7 # Software Foundation; version 2.1 of the License. details.
8 #
9 # You should have received a copy of the GNU Lesser General Public License
10 # along with this library; if not, write to the Free Software Foundation, Inc.,
11 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
12
13 CURDIR=$(dirname $0)/
14 TESTDIR=$CURDIR/..
15 LAUNCH_APP="launch_ust_app"
16 KILL_RELAYD_HELPER="kill_relayd"
17 SESSION_NAME="stress"
18 EVENT_NAME="tp:tptest"
19 LOG_FILE_SESSIOND="sessiond.log"
20 LOG_FILE_RELAYD="relayd.log"
21 CHANNEL_NAME="channel0"
22 NR_APP=5
23 NR_SESSION=5
24 NR_LOOP=100000
25 COREDUMP_FILE=$(cat /proc/sys/kernel/core_pattern)
26 NUM_TESTS=16
27 APPS_PID=
28
29 TEST_DESC="Stress test - $NR_SESSION sessions per UID streaming with $NR_APP apps. The relayd is killed sporadically"
30
31 source $TESTDIR/utils/utils.sh
32
33 # MUST set TESTDIR before calling those functions
34
35 function enable_channel_per_uid()
36 {
37 local sess_name=$1
38 local channel_name=$2
39
40 $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel --buffers-uid -u $channel_name -s $sess_name >/dev/null 2>&1
41 ok $? "Enable channel $channel_name per UID for session $sess_name"
42 }
43
44 function check_sessiond()
45 {
46 if [ -z "$(pgrep --full lt-lttng-sessiond)" ]; then
47 local str_date=$(date +%H%M%S-%d%m%Y)
48
49 diag "!!!The session daemon died unexpectedly!!!"
50 mv $LOG_FILE_SESSIOND $LOG_FILE_SESSIOND-$str_date
51 if [ -e $COREDUMP_FILE ]; then
52 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
53 fi
54 exit 1
55 fi
56 }
57
58 function start_sessiond()
59 {
60 validate_kernel_version
61 if [ $? -ne 0 ]; then
62 fail "Start session daemon"
63 BAIL_OUT "*** Kernel too old for session daemon tests ***"
64 fi
65
66 if [ -z $(pgrep --full lt-$SESSIOND_BIN) ]; then
67 # We have to start it like this so the ulimit -c is used by this
68 # process. Also, we collect any error message printed out.
69 #$TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --quiet --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE_SESSIOND 2>&1
70 $TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --verbose-consumer -vvv --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE_SESSIOND 2>&1
71 #$TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE_SESSIOND 2>&1
72 status=$?
73 ok $status "Start session daemon"
74 fi
75 }
76
77 function start_relayd
78 {
79 local opt=$1
80
81 if [ -z $(pgrep --full lt-$RELAYD_BIN) ]; then
82 $TESTDIR/../src/bin/lttng-relayd/$RELAYD_BIN $opt >$LOG_FILE_RELAYD 2>&1 &
83 ok $? "Start lttng-relayd (opt: \"$opt\")"
84 fi
85 }
86
87 function check_relayd()
88 {
89 if [ -z "$(pgrep --full lt-lttng-relayd)" ]; then
90 local str_date=$(date +%H%M%S-%d%m%Y)
91
92 #diag "Relay daemon died. Starting it again"
93 if [ -e $COREDUMP_FILE ]; then
94 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
95 fi
96 start_relayd
97 fi
98 }
99
100 test_stress()
101 {
102 for b in $(seq 1 $NR_LOOP); do
103 for a in $(seq 1 $NR_SESSION); do
104 create_lttng_session_uri $SESSION_NAME-$a net://localhost
105 check_sessiond
106 check_relayd
107 enable_channel_per_uid $SESSION_NAME-$a $CHANNEL_NAME
108 check_sessiond
109 check_relayd
110 enable_ust_lttng_event_ok $SESSION_NAME-$a $EVENT_NAME
111 check_sessiond
112 check_relayd
113 start_lttng_tracing_ok $SESSION_NAME-$a
114 check_sessiond
115 check_relayd
116 done
117
118 for a in $(seq 1 $NR_SESSION); do
119 stop_lttng_tracing_ok $SESSION_NAME-$a
120 check_sessiond
121 check_relayd
122 destroy_lttng_session_ok $SESSION_NAME-$a
123 check_sessiond
124 check_relayd
125 done
126 done
127
128 return 0
129 }
130
131 function cleanup()
132 {
133 diag "Cleaning up!"
134 for p in ${APPS_PID}; do
135 kill ${p}
136 wait ${p} 2>/dev/null
137 done
138 APPS_PID=
139 stop_lttng_sessiond
140 stop_lttng_relayd
141 }
142
143 function sighandler()
144 {
145 cleanup
146 #rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
147 exit 1
148 }
149
150 trap sighandler SIGINT
151 trap sighandler SIGTERM
152
153 # Make sure we collect a coredump if possible.
154 ulimit -c unlimited
155
156 # MUST set TESTDIR before calling those functions
157 plan_tests $NUM_TESTS
158
159 print_test_banner "$TEST_DESC"
160
161 TRACE_PATH=$(mktemp -d)
162
163 start_relayd "-o $TRACE_PATH"
164 start_sessiond
165
166 diag "Starting applications launcher"
167
168 # Start NR_APP applications script that will spawn apps non stop.
169 ./$TESTDIR/stress/$LAUNCH_APP $NR_APP &
170 APPS_PID="${APPS_PID} ${!}"
171
172 # Launch the helper script that will randomly kill the relayd at vitam eternam.
173 ./$TESTDIR/stress/$KILL_RELAYD_HELPER 1 1 &
174 APPS_PID="${APPS_PID} ${!}"
175
176 test_stress
177 out=$?
178 if [ $out -ne 0 ]; then
179 cleanup
180 exit $out
181 fi
182
183 cleanup
184 rm -rf $TRACE_PATH
185 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
186 exit 0
This page took 0.034261 seconds and 4 git commands to generate.